#include "utility.h"

extern LPCSTR pszAppName;
extern HINSTANCE g_hInstance;
extern HWND g_hParent;

void ErrorMessage(LPCSTR pszMessage)
{
	MessageBox(
		g_hParent ? g_hParent : NULL,
		pszMessage,
		pszAppName,
		MB_TOPMOST | MB_OK);
}


BOOL ShowWindowEx(HWND hWnd, int nShowCmd)
{
	BOOL bReturn = FALSE;
	
	if (IsWindow(hWnd))
	{
		BOOL bVisible = IsWindowVisible(hWnd);
		
		if (nShowCmd == SW_TOGGLE)
		{
			bReturn = ShowWindow(hWnd, bVisible ? SW_HIDE : SW_SHOW);
		}
		else
		{
			if ((bVisible && (nShowCmd == SW_HIDE)) || (!bVisible && (nShowCmd == SW_SHOW)))
			{
				bReturn = ShowWindow(hWnd, nShowCmd);
			}		
		}
	}

	return bReturn;
}


BOOL ConfigureAuroraWnd(HWND& hWnd, const int& x, const int& y, const UINT& width, const UINT& height)
{
	BOOL bReturn = FALSE;
	
	if (IsWindow(hWnd))
	{
		bReturn = MoveWindow(hWnd, x, y, width, height, true);
	}
	else
	{
		hWnd = CreateWindowEx(
			WS_EX_NOPARENTNOTIFY | WS_EX_TOOLWINDOW | WS_EX_TOPMOST,
			pszAppName,
			NULL,
			WS_DISABLED | WS_POPUP,
			x, y, width, height,
			g_hParent,
			NULL,
			g_hInstance,
			0);
		
		if (IsWindow(hWnd))
		{
			SetWindowLong(hWnd, GWL_USERDATA, magicDWord);
			bReturn = TRUE;
		}
		else
		{
			hWnd = NULL;
		}
	}

	return bReturn;
}
